# makefile

# MACRO

#MATRIXDIR  = /home/sakai/cppClassLib/matrix
#RKISCDIR   = /home/sakai/cppClassLib/rkisc
LIBS      = -lm

CC        = g++
CFLAGS	  = -c -g

# -c: Compile the source file, but do not link.
# -g: Produce debugging information.

LD        = g++
LDFLAGS   = -o

# RULES

# main program

main	:	main.o makeGridData.o 
	$(LD) $(LDFLAGS) main main.o makeGridData.o $(LIBS)

main.o	:	main.cc
	$(CC) $(CFLAGS) main.cc

makeGridData.o	:	makeGridData.cc makeGridData.h
	$(CC) $(CFLAGS) makeGridData.cc
