/* makeGridData.cc
--------------------------------
 饹 MakeGridData μ¸
--------------------------------
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include<math.h>

#include "makeGridData.h"

// 󥹥ȥ饯
MakeGridData :: MakeGridData
(
 char* idx_f_name,
 char* grid_f_name,   // ˳ݤ륰åɤλͶκɸ򵭤ե
 int S_year,
 int E_year
 )
{
  int i, j;
  FILE* fp_grid;
  char buf[256];
  int counter;

  start_year = S_year;
  end_year = E_year;

  
  int tmp = 0;
  for(i = start_year; i < end_year+1; i++){
    if((i % 4) == 3) tmp += 366;
    else tmp += 365;
  }

  Num_of_data = tmp;
  printf("Num_of_data = %d\n", Num_of_data);
  
  if((fp_grid = fopen(grid_f_name, "r")) == NULL){
    printf("File cannot open !\n");
    exit(1);
  }

  // ׻ץ׻롣
  MACEPS = maceps();
  // 100ܤΤѤ롣
  MACEPS = MACEPS*100;

  // Υեˤϣܤ˥åɿȳĥҤ񤤤Ƥ롣
  int ngrid;
  char head[50];
  char g_x[10], g_y[10];
  double x0, y0, x1, y1, x2, y2, x3, y3;
  char op_f_name[50];

  while(fgets(buf, 256, fp_grid) != NULL){
    
    // ȹԡԤν
    if((buf[0] == '#') || (buf[0] == '\n')) continue;

    else{
      if(sscanf(buf, "%d %s", &ngrid, head) != 2){
	printf("Cannot scan number of grids.\n");
	exit(1);
      }
      Num_of_grid = ngrid;
      printf("Num_of_grid = %d\n", Num_of_grid);

      // γݡ
      grid = new Grid[Num_of_grid];
      for(i = 0; i < Num_of_grid; i++){
	strcpy(grid[i].g_num, "\0");
	for(j = 0; j < 4; j++){
	  grid[i].x[j] = 0.0;
	  grid[i].y[j] = 0.0;
	}
	grid[i].count = 0;
      }
      break;
    }
  }

  j = 0;
  while(fgets(buf, 256, fp_grid) != NULL){
    // ȹԡԤν
    if((buf[0] == '#') || (buf[0] == '\n')) continue;
    
    else{
      if(sscanf(buf, "%s %s %lf %lf %lf %lf %lf %lf %lf %lf",
		g_x, g_y, &x0, &y0, &x1, &y1, &x2, &y2, &x3, &y3) 
	 != 10){
	printf("Cannot scan the New Grid data.\n");
	exit(1);
      }
      strcat(g_x, "-");
      strcat(g_x, g_y);
      strcpy(op_f_name, head);
      strcat(op_f_name, "-");
      strcat(op_f_name, g_x);
      strcat(op_f_name, ".rain");
      strcpy(grid[j].g_num, op_f_name);
      
//          printf("grid[%d].g_num = %s\n", j, grid[j].g_num);

      grid[j].x[0] = x0; grid[j].y[0] = y0;
      grid[j].x[1] = x1; grid[j].y[1] = y1;
      grid[j].x[2] = x2; grid[j].y[2] = y2;
      grid[j].x[3] = x3; grid[j].y[3] = y3;
	//	  printf("grid[%d].x[%d] = %lf, grid[%d].y[%d] = %lf\n",
//	       j, 0, grid[j].x[0], j, 0, grid[j].y[0]);

      j++;
	
    }
  }

  for(i = 0; i < Num_of_grid; i++){
    Sort_Stations(i, idx_f_name);
    printf("*** Now generating '%s' ***\n", grid[i].g_num);
    Calculate_Grid_Average(i);
  }
}


MakeGridData :: ~MakeGridData(void)
{
  delete [] grid;
}

void MakeGridData :: Sort_Stations(int g_code, char* idx_f_name)
{
  FILE* fp_idx;
  char buf[256];
  double lon, lat;
  char data_f_name[50];
  int location;
  int COUNT = 0;
  int i;
  char** fn_tmp;
  double X_avg, Y_avg;         /* åɻͶκɸʿ(κɸ
				  å濴Ȥ) */
  double* kyori;

  X_avg = (grid[g_code].x[0] + grid[g_code].x[1] + grid[g_code].x[2]
	   + grid[g_code].x[3])/4;
  Y_avg = (grid[g_code].y[0] + grid[g_code].y[1] + grid[g_code].y[2]
	   + grid[g_code].y[3])/4;

  fn_tmp = new char*[1000];
  kyori = new double[1000];
  for(i = 0; i < 1000; i++){
    fn_tmp[i] = new char[256];
    strcpy(fn_tmp[i], "\0");
    kyori[i] = 0.;
  }

  if((fp_idx = fopen(idx_f_name, "r")) == NULL){
    printf("Cannot open index file !\n");
    exit(1);
  }

  // ǥåե뤫顢åˤ¬ܤ
  while(fgets(buf, 256, fp_idx) != NULL){

    // ȹԡԤν
    if((buf[0] == '#') || (buf[0] == '\n')) continue;
    else{
      if(sscanf(buf, "%lf %lf %s", &lon, &lat, &data_f_name) != 3){
	printf("Cannot scan Index Data !!\n");
	exit(1);
      }
      
      location = Loc_Station(g_code, lon, lat);
      
      // åվ塢վ塢ѤΤȤ
      if((location == 0) || (location == 1) || (location == 3)
	 || (location == 7)){
	strcpy(fn_tmp[COUNT], data_f_name);
	kyori[COUNT] = sqrt(pow((lon - X_avg),2) + pow((lat - Y_avg),2));
//	printf("%s\n", fn_tmp[COUNT]);
	COUNT++;
      }

//      printf("lon = %lf, lat = %lf, data_file = %s\n",
//	     lon, lat, data_f_name);
    }
  }

  fclose(fp_idx);

//  printf("COUNT = %d\n", COUNT);

  // å˴¬꤬ʤȤ
  if(COUNT <= 3){

    // å濴˶ᤤ num_st Ĥδ¬ΥǡʿѤ
    // ΥåɤΥǡ롣

    int num_st = 10;             /* ǡоݤȤʤ¬ */
    double* distance;            /* å濴ȴ¬εΥû */
    double dis_tmp;              /* å濴Ȥδ¬εΥΣ */
    double dis_max;
    int max = 0;

    grid[g_code].count = num_st;

    distance = new double[num_st];
    for(i = 0; i < num_st; i++){
      distance[i] = 999999.;      
    }

    fp_idx = fopen(idx_f_name, "r");

    while(fgets(buf, 256, fp_idx) != NULL){

      // ȹԡԤν
      if((buf[0] == '#') || (buf[0] == '\n')) continue;
      else{
	if(sscanf(buf, "%lf %lf %s", &lon, &lat, &data_f_name) != 3){
	  printf("Cannot scan Index Data !!\n");
	  exit(1);
	}

	dis_tmp = pow((lon - X_avg),2) + pow((lat - Y_avg),2);

	if(dis_tmp < distance[max]){
	  distance[max] = sqrt(dis_tmp);
	  strcpy(fn_tmp[max], data_f_name);


	  dis_max = -99.;
	  for(i = 0; i < num_st; i++){
	    if(distance[i] > dis_max){
	      dis_max = distance[i];
	      max = i;
	    }
	  }
	}
      }
    }
    
    fclose(fp_idx);

    grid[g_code].file_name = new char*[num_st];
    grid[g_code].Dis = new double[num_st];
    for(i = 0; i < num_st; i++){
      grid[g_code].file_name[i] = new char[256];
      grid[g_code].Dis[i] = 0.;
    }
    for(i = 0; i < num_st; i++){
      strcpy(grid[g_code].file_name[i], fn_tmp[i]);
      grid[g_code].Dis[i] = distance[i];
//      printf("%s\n", fn_tmp[i]);
    }
    delete [] distance;
  }
  
  
  else{
    grid[g_code].count = COUNT;
    //  printf("grid[%d].count = %d\n", g_code, grid[g_code].count);

    // γݡ
    grid[g_code].file_name = new char*[COUNT];
    grid[g_code].Dis = new double[COUNT];
    for(i = 0; i < COUNT; i++){
      grid[g_code].file_name[i] = new char[256];
      grid[g_code].Dis[i] = 0.;
    }
    for(i = 0; i < grid[g_code].count; i++){
      strcpy(grid[g_code].file_name[i], "\0");
    }

    // ե̾˳Ǽ롣
    for(i = 0; i < grid[g_code].count; i++){
      strcpy(grid[g_code].file_name[i], fn_tmp[i]);
      grid[g_code].Dis[i] = kyori[i];
      //    printf("grid[%d].file_name[%d] = %s\n", g_code, i,
      //	   grid[g_code].file_name[i]);
    }
  }
  
  // fn_tmp ˲
  for(i = 0; i < 1000; i++){
    delete [] fn_tmp[i];
  }
  delete [] fn_tmp;
  delete [] kyori;
}


// åΥǡ򻻽ʿѤեϤ롣
void MakeGridData :: Calculate_Grid_Average(int g_code)
{
  FILE* fp_i;           /* ϥե */
  FILE* fp_o;           /* ϥե */
  int i, j, k;
  int day;
  int code, year, month, jun;
  int num_of_data;
  char buf[256];
  double rain;          /* ե뤫ɤ߼äǡ */
  double* sum;          /* Ȥι */
  double* COUNT;        /* ͭʥǡ(¬) */


  // γݡ
  sum = new double[Num_of_data];
  COUNT = new double[Num_of_data];

  for(i = 0; i < Num_of_data; i++){
    sum[i] = 0.0;
    COUNT[i] = 0.0;
  }

  char* pbuf;

  for(i = 0; i < grid[g_code].count; i++){
    if((fp_i = fopen(grid[g_code].file_name[i], "r")) == NULL){
      printf("Cannot open '%s' !\n", grid[g_code].file_name[i]);
      exit(1);
    }
    day = 0;
    int line = 0;
    while(fgets(buf, 256, fp_i) != NULL){
      line++;
      pbuf = buf;

      // ȹԡԤν
      if((buf[0] == '#') || (buf[0] == '\n')) continue;

      // ڡ򥹥å
      while((*pbuf == ' ') || (*pbuf == '\t')) pbuf++;

      // ɤɤ
      if(sscanf(pbuf, "%4d", &code) != 1){
	printf("There are wrong data(about code) in '%s' ,line %d !\n",
	       grid[g_code].file_name[i], line);
	exit(1);
      }

      // ɤʤ
// modified by Yutaka ICHIKAWA (Thu May 17 12:35:55 2001)
//       while((*pbuf != ' ') && (*pbuf != NULL)) pbuf++;
      while((*pbuf != ' ') && (*pbuf != '\t') && (*pbuf != '\0')) pbuf++;
      while((*pbuf == ' ') || (*pbuf == '\t')) pbuf++;

      // ǯȷɤ
      if(sscanf(pbuf, "%4d%2d", &year, &month) != 2){
	printf("%s\n", pbuf);
	printf("There are wrong data(about year or month) in '%s' ,line %d !\n",
	       grid[g_code].file_name[i], line);
	exit(1);
      }

      // ɤʤ
// modified by Yutaka ICHIKAWA (Thu May 17 12:35:55 2001)
//      while((*pbuf != ' ') && (*pbuf != NULL)) pbuf++;
      while((*pbuf != ' ') && (*pbuf != '\t') && (*pbuf != '\0')) pbuf++;
      while((*pbuf == ' ') || (*pbuf == '\t')) pbuf++;

      // (塦桦)ɤ
      if(sscanf(pbuf, "%d", &jun) != 1){
	printf("There are wrong data(about jun) in '%s' ,line %d !\n",
	       grid[g_code].file_name[i], line);
	exit(1);
      }

      // ɤʤ
// modified by Yutaka ICHIKAWA (Thu May 17 12:35:55 2001)
//      while((*pbuf != ' ') && (*pbuf != NULL)) pbuf++;
      while((*pbuf != ' ') && (*pbuf != '\t') && (*pbuf != '\0')) pbuf++;
      while((*pbuf == ' ') || (*pbuf == '\t')) pbuf++;


      // ǯΥǡʤС
      if((year >= start_year) && (year <= end_year)){
//	printf("%4d  %4d %2d %1d\n", code, year, month, jun);

	// Ʒξܤ(ŤĤ)
	if(jun != 3) num_of_data = 10;

	// Ʒβ(ǯˤäƥǡۤʤ)
	else{
	  // ǯΣ
	  if((year%4 == 3) && (month == 11)) num_of_data = 9;

	  // ¾ǯΣ
	  else if((year%4 != 3) && (month == 11)) num_of_data = 8;

	  // ,,,
	  else if((month == 1) || (month == 3) 
		  || (month == 6) || (month == 8)) num_of_data = 10;

	  // ,,,,,,
	  else num_of_data = 11;
	}

//	printf("num_of_data = %d\n", num_of_data);
	
	for(k = 0; k < num_of_data; k++){
	  if(sscanf(pbuf, "%lf", &rain) != 1){
	    printf("There are wrong data in '%s', line %d !\n", 
		   grid[g_code].file_name[i], line);
	    exit(1);
	  }

/*	  if((code == 7018) && (year == 1983) && (month == 6)){
	    printf("code = %d year = %d month = %d jun = %d rain = %f\n",
		   code, year, month, jun, rain);
	  }
*/
	  // ¬ξ -99.99 äƤ롣
	  if(rain >= 0.0){
	    sum[day] += rain/(pow(grid[g_code].Dis[i], 1));
	    COUNT[day] += 1/(pow(grid[g_code].Dis[i], 1));
//	    printf("sum[%d] = %lf\n", day, sum[day]);
	    day++;
	  } 
	  // ɤʤ
// modified by Yutaka ICHIKAWA (Thu May 17 12:35:55 2001)
//	  while((*pbuf != ' ') && (*pbuf != NULL)) pbuf++;
      while((*pbuf != ' ') && (*pbuf != '\t') && (*pbuf != '\0')) pbuf++;
	  while((*pbuf == ' ') || (*pbuf == '\t')) pbuf++;
	}
	
      }
    }

    fclose(fp_i);
  }

/*  for(k = 0; k < Num_of_data; k++){
    if(COUNT[k] == 0){
      
    }
  }
*/

  // ʿͤ
  fp_o = fopen(grid[g_code].g_num, "w");

  fprintf(fp_o, "# %s\n", grid[g_code].g_num);
  fprintf(fp_o, "# from %d to %d\n", start_year, end_year);
  fprintf(fp_o, "\n");

  for(i = 0; i < Num_of_data; i++){

    if(COUNT[i] == 0){
//      printf("¬ꡣ\n");
      printf("%s\n", grid[g_code].g_num);
      sum[i] = 5;
      COUNT[i] = -1;
    }
    // ֤ñ̤ѴΤȡǡʿͤեϤ롣
    fprintf(fp_o, "%d %f\n", i*86400, sum[i]/COUNT[i]);

  }
  fclose(fp_o);

  delete [] sum;
  delete [] COUNT;

}


int MakeGridData :: Loc_Station(int g_number, double Lon, double Lat)
{
  int i, loc[4];
  double s, b;
  
  for(i = 0; i < 4; i++){
    s = (Lon - grid[g_number].x[i+1])
      *(grid[g_number].y[i] - grid[g_number].y[i+1])
	- (grid[g_number].x[i] - grid[g_number].x[i+1])
	  *(Lat - grid[g_number].y[i+1]);

    b = pow(grid[g_number].x[i] - grid[g_number].x[i+1], 2)
      + pow(grid[g_number].y[i] - grid[g_number].y[i+1], 2);
    
    b = sqrt(b)*MACEPS;

    if(b < s){           /* դ¦ */
      loc[i] = 1;
    }
    else if((-b <= s) && (s <= b)){      /* վ */
      loc[i] = 0;
    }
    else{                 /* åɤγ¦ */
      return(-1);
    }
  }

  if((loc[0] == 1) && (loc[1] == 1) && (loc[2] == 1) && (loc[3] == 1)){
    return(0);           // å
  }
  else if (loc[0] == 0 && loc[1] == 1 && loc[2] == 1 && loc[3] == 1) { 
    return(1); // վ
  }
  else if (loc[0] == 1 && loc[1] == 0 && loc[2] == 1 && loc[3] == 1) { 
    return(2); // վ
  }
  else if (loc[0] == 1 && loc[1] == 1 && loc[2] == 0 && loc[3] == 1) { 
    return(3); // վ
  }
  else if (loc[0] == 1 && loc[1] == 1 && loc[2] == 1 && loc[3] == 0) { 
    return(4); // վ
  }
  else if (loc[0] == 0 && loc[3] == 0) { 
    return(5); // 
  }
  else if (loc[0] == 0 && loc[1] == 0) { 
    return(6); // 
  }
  else if (loc[1] == 0 && loc[2] == 0) { 
    return(7); // 
  }
  else if (loc[2] == 0 && loc[3] == 0) { 
    return(8); // 
  }
  else { 
    return(99); // ǡ
  }
}
  

float MakeGridData :: maceps(void)
{
  float e, w;

  e = 1; w = 1 + e;
  while (w > 1) {
//    printf("% -14g % -14g % -14g\n", e, w, w-1);
    e /= 2; w = 1 + e;
  }
  return(e*2);
}
